/*
 * Sixth 3D engine. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 */
package eu.svjatoslav.sixth.e3d.gui.humaninput;

import eu.svjatoslav.sixth.e3d.geometry.Point2D;

/**
 * Represents mouse event.
 */
public class MouseEvent {

    /**
     * Mouse coordinate in screen space (pixels) relative to top left corner of the screen
     * when mouse button was clicked.
     */
    public Point2D coordinate;

    /**
     * <pre>
     * 0 - mouse over (no button pressed)
     * 1 - left mouse button
     * 2 - middle mouse button
     * 3 - right mouse button
     * </pre>
     */
    public int button;

    MouseEvent(final int x, final int y, final int button) {
        this(new Point2D(x, y), button);
    }

    MouseEvent(final Point2D coordinate, final int button) {
        this.coordinate = coordinate;
        this.button = button;
    }

    @Override
    public String toString() {
        return "MouseEvent{" +
                "coordinate=" + coordinate +
                ", button=" + button +
                '}';
    }
}
