/*
 * Sixth 3D engine. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 */
package eu.svjatoslav.sixth.e3d.renderer.octree.raytracer;

public class Ray {

    // ray origin
    public double x, y, z;

    // ray direction
    public double xp, yp, zp;

    // ray hit point
    public double hitX, hitY, hitZ;


    public int hitCellSize;

    public int hitCellX, hitCellY, hitCellZ;

    public Ray(final double X, final double Y, final double Z, final double Xp,
               final double Yp, final double Zp) {
        x = X;
        y = Y;
        z = Z;
        xp = Xp;
        yp = Yp;
        zp = Zp;
    }


    @Override
    public String toString() {
        return "Ray \n" + "	x " + x + "\n" + "	y " + y + "\n" + "	z " + z
                + "\n" + "	xp " + xp + "\n" + "	yp " + yp + "\n" + " 	zp " + zp
                + "\n";
    }
}
