/*
 * Sixth 3D engine. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 */
package eu.svjatoslav.sixth.e3d.renderer.raster.shapes;

import eu.svjatoslav.sixth.e3d.gui.RenderingContext;
import eu.svjatoslav.sixth.e3d.gui.humaninput.MouseInteractionController;
import eu.svjatoslav.sixth.e3d.math.TransformsPipeline;
import eu.svjatoslav.sixth.e3d.renderer.raster.RenderAggregator;

public abstract class AbstractShape {

    public MouseInteractionController mouseInteractionController;

    public void setMouseInteractionController(
            final MouseInteractionController mouseInteractionController) {
        this.mouseInteractionController = mouseInteractionController;
    }

    public abstract void transform(final TransformsPipeline transforms,
                                   final RenderAggregator aggregator,
                                   final RenderingContext renderingContext);

}
