/*
 * Sixth 3D engine. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 */
package eu.svjatoslav.sixth.e3d.renderer.raster.shapes.basic.line;

public class LineInterpolator {

    private double x1, y1, d1, x2, y2, d2;

    private double d;
    private int height;
    private int width;
    private double dinc;

    public boolean containsY(final int y) {

        if (y1 < y2) {
            if (y >= y1)
                if (y <= y2)
                    return true;
        } else if (y >= y2)
            if (y <= y1)
                return true;

        return false;
    }

    public double getD() {
        return d;
    }

    public int getX(final int y) {
        if (height == 0)
            return (int) (x2 + x1) / 2;

        final int distanceFromY1 = y - (int) y1;

        d = d1 + ((dinc * distanceFromY1) / height);

        return (int) x1 + ((width * distanceFromY1) / height);
    }

    public void setPoints(final double x1, final double y1, final double d1,
                          final double x2, final double y2, final double d2) {

        this.x1 = x1;
        this.y1 = y1;
        this.d1 = d1;

        this.x2 = x2;
        this.y2 = y2;
        this.d2 = d2;

        height = (int) y2 - (int) y1;
        width = (int) x2 - (int) x1;

        dinc = d2 - d1;
    }
}
