/*
 * Sixth 3D engine. Author: Svjatoslav Agejenko.
 * This project is released under Creative Commons Zero (CC0) license.
 */
package eu.svjatoslav.sixth.e3d.renderer.raster.shapes.composite;

import eu.svjatoslav.sixth.e3d.geometry.Point3D;
import eu.svjatoslav.sixth.e3d.renderer.raster.Color;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.basic.line.LineAppearance;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.composite.base.AbstractCompositeShape;

public class LightSourceMarker extends AbstractCompositeShape {

    public LightSourceMarker(final Point3D location, final Color color) {
        super(location);
        final LineAppearance appearance = new LineAppearance(10);

        final int markerSize = 10;

        addShape(appearance.getLine(new Point3D(0, -markerSize, 0),
                new Point3D(markerSize, markerSize, -markerSize), color));
        addShape(appearance.getLine(new Point3D(0, -markerSize, 0),
                new Point3D(-markerSize, markerSize, -markerSize), color));
        addShape(appearance.getLine(new Point3D(0, -markerSize, 0),
                new Point3D(0, markerSize, markerSize), color));

        addShape(appearance.getLine(new Point3D(-markerSize, markerSize,
                        -markerSize), new Point3D(markerSize, markerSize, -markerSize),
                color));
        addShape(appearance.getLine(new Point3D(-markerSize, markerSize,
                -markerSize), new Point3D(0, markerSize, markerSize), color));
        addShape(appearance.getLine(new Point3D(0, markerSize, markerSize),
                new Point3D(markerSize, markerSize, -markerSize), color));
    }
}
